<!DOCTYPE HTML>
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (15) on Fri Jun 18 20:43:06 CEST 2021 -->
<title>BookController</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta name="dc.created" content="2021-06-18">
<meta name="description" content="declaration: package: fr.iut.librarymanagement.controller, class: BookController">
<meta name="generator" content="javadoc/ClassWriterImpl">
<link rel="stylesheet" type="text/css" href="../../../../stylesheet.css" title="Style">
<link rel="stylesheet" type="text/css" href="../../../../script-dir/jquery-ui.min.css" title="Style">
<link rel="stylesheet" type="text/css" href="../../../../jquery-ui.overrides.css" title="Style">
<script type="text/javascript" src="../../../../script.js"></script>
<script type="text/javascript" src="../../../../script-dir/jquery-3.5.1.min.js"></script>
<script type="text/javascript" src="../../../../script-dir/jquery-ui.min.js"></script>
</head>
<body class="class-declaration-page">
<script type="text/javascript">var data = {"i0":10,"i1":10,"i2":10,"i3":10,"i4":10,"i5":10,"i6":10,"i7":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "alt-color";
var rowColor = "row-color";
var tableTab = "table-tab";
var activeTableTab = "active-table-tab";
var pathtoroot = "../../../../";
loadScripts(document, 'script');</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<div class="flex-box">
<header role="banner" class="flex-header">
<nav role="navigation">
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="top-nav" id="navbar.top">
<div class="skip-nav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<ul id="navbar.top.firstrow" class="nav-list" title="Navigation">
<li><a href="../../../../index.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="nav-bar-cell1-rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-files/index-1.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="sub-nav">
<div>
<ul class="sub-nav-list">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="sub-nav-list">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<div class="nav-list-search"><label for="search">SEARCH:</label>
<input type="text" id="search" value="search" disabled="disabled">
<input type="reset" id="reset" value="reset" disabled="disabled">
</div>
</div>
<!-- ========= END OF TOP NAVBAR ========= -->
<span class="skip-nav" id="skip.navbar.top">
<!--   -->
</span></nav>
</header>
<div class="flex-content">
<main role="main">
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="sub-title"><span class="package-label-in-type">Package</span>&nbsp;<a href="package-summary.html">fr.iut.librarymanagement.controller</a></div>
<h1 title="Class BookController" class="title">Class BookController</h1>
</div>
<div class="inheritance" title="Inheritance Tree">java.lang.Object
<div class="inheritance">fr.iut.librarymanagement.controller.BookController</div>
</div>
<section class="description">
<hr>
<pre>@RestController
public class <span class="type-name-label">BookController</span>
extends java.lang.Object</pre>
<div class="block">Controller for books</div>
<dl class="notes">
<dt>See Also:</dt>
<dd><a href="../domain/Book.html" title="class in fr.iut.librarymanagement.domain"><code>Book</code></a></dd>
</dl>
</section>
<section class="summary">
<ul class="summary-list">
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<li>
<section class="constructor-summary" id="constructor.summary">
<h2>Constructor Summary</h2>
<div class="member-summary">
<table class="summary-table">
<caption><span>Constructors</span></caption>
<thead>
<tr>
<th class="col-first" scope="col">Constructor</th>
<th class="col-last" scope="col">Description</th>
</tr>
</thead>
<tbody>
<tr class="alt-color">
<th class="col-constructor-name" scope="row"><code><span class="member-name-link"><a href="#%3Cinit%3E(fr.iut.librarymanagement.repository.BookRepository)">BookController</a></span>&#8203;(<a href="../repository/BookRepository.html" title="interface in fr.iut.librarymanagement.repository">BookRepository</a>&nbsp;bookRepository)</code></th>
<td class="col-last">&nbsp;</td>
</tr>
</tbody>
</table>
</div>
</section>
</li>
<!-- ========== METHOD SUMMARY =========== -->
<li>
<section class="method-summary" id="method.summary">
<h2>Method Summary</h2>
<div class="member-summary" id="method-summary-table">
<div class="table-tabs" role="tablist" aria-orientation="horizontal"><button role="tab" aria-selected="true" aria-controls="method-summary-table.tabpanel" tabindex="0" onkeydown="switchTab(event)" id="t0" class="active-table-tab">All Methods</button><button role="tab" aria-selected="false" aria-controls="method-summary-table.tabpanel" tabindex="-1" onkeydown="switchTab(event)" id="t2" class="table-tab" onclick="show(2);">Instance Methods</button><button role="tab" aria-selected="false" aria-controls="method-summary-table.tabpanel" tabindex="-1" onkeydown="switchTab(event)" id="t4" class="table-tab" onclick="show(8);">Concrete Methods</button></div>
<div id="method-summary-table.tabpanel" role="tabpanel">
<table class="summary-table" aria-labelledby="t0">
<thead>
<tr>
<th class="col-first" scope="col">Modifier and Type</th>
<th class="col-second" scope="col">Method</th>
<th class="col-last" scope="col">Description</th>
</tr>
</thead>
<tbody>
<tr class="alt-color" id="i0">
<td class="col-first"><code><a href="../domain/Book.html" title="class in fr.iut.librarymanagement.domain">Book</a></code></td>
<th class="col-second" scope="row"><code><span class="member-name-link"><a href="#addBook(fr.iut.librarymanagement.domain.Book)">addBook</a></span>&#8203;(<a href="../domain/Book.html" title="class in fr.iut.librarymanagement.domain">Book</a>&nbsp;book)</code></th>
<td class="col-last">
<div class="block">Create an book</div>
</td>
</tr>
<tr class="row-color" id="i1">
<td class="col-first"><code><a href="../domain/Book.html" title="class in fr.iut.librarymanagement.domain">Book</a></code></td>
<th class="col-second" scope="row"><code><span class="member-name-link"><a href="#addOpinion(java.lang.Long,fr.iut.librarymanagement.domain.Opinion)">addOpinion</a></span>&#8203;(java.lang.Long&nbsp;isbn,
<a href="../domain/Opinion.html" title="class in fr.iut.librarymanagement.domain">Opinion</a>&nbsp;opinion)</code></th>
<td class="col-last">
<div class="block">Add an opinion to a book</div>
</td>
</tr>
<tr class="alt-color" id="i2">
<td class="col-first"><code><a href="../domain/Book.html" title="class in fr.iut.librarymanagement.domain">Book</a></code></td>
<th class="col-second" scope="row"><code><span class="member-name-link"><a href="#addUser(java.lang.Long,org.bson.types.ObjectId)">addUser</a></span>&#8203;(java.lang.Long&nbsp;isbn,
org.bson.types.ObjectId&nbsp;userId)</code></th>
<td class="col-last">
<div class="block">Add a user who has borrowed a book</div>
</td>
</tr>
<tr class="row-color" id="i3">
<td class="col-first"><code>java.util.List&lt;<a href="../domain/Book.html" title="class in fr.iut.librarymanagement.domain">Book</a>&gt;</code></td>
<th class="col-second" scope="row"><code><span class="member-name-link"><a href="#bookList(java.lang.String)">bookList</a></span>&#8203;(java.lang.String&nbsp;title)</code></th>
<td class="col-last">
<div class="block">Get all books, or looking for all books by title</div>
</td>
</tr>
<tr class="alt-color" id="i4">
<td class="col-first"><code>java.util.List&lt;<a href="../domain/Book.html" title="class in fr.iut.librarymanagement.domain">Book</a>&gt;</code></td>
<th class="col-second" scope="row"><code><span class="member-name-link"><a href="#bookUserList(org.bson.types.ObjectId)">bookUserList</a></span>&#8203;(org.bson.types.ObjectId&nbsp;userId)</code></th>
<td class="col-last">
<div class="block">Get all books borrowed by an user</div>
</td>
</tr>
<tr class="row-color" id="i5">
<td class="col-first"><code>void</code></td>
<th class="col-second" scope="row"><code><span class="member-name-link"><a href="#deleteBook(java.lang.Long)">deleteBook</a></span>&#8203;(java.lang.Long&nbsp;isbn)</code></th>
<td class="col-last">
<div class="block">Delete a book</div>
</td>
</tr>
<tr class="alt-color" id="i6">
<td class="col-first"><code><a href="../domain/Book.html" title="class in fr.iut.librarymanagement.domain">Book</a></code></td>
<th class="col-second" scope="row"><code><span class="member-name-link"><a href="#editBook(java.lang.Long,java.lang.String,java.lang.String)">editBook</a></span>&#8203;(java.lang.Long&nbsp;isbn,
java.lang.String&nbsp;title,
java.lang.String&nbsp;summary)</code></th>
<td class="col-last">
<div class="block">Update a book</div>
</td>
</tr>
<tr class="row-color" id="i7">
<td class="col-first"><code><a href="../domain/Book.html" title="class in fr.iut.librarymanagement.domain">Book</a></code></td>
<th class="col-second" scope="row"><code><span class="member-name-link"><a href="#getBookByIsbn(java.lang.Long)">getBookByIsbn</a></span>&#8203;(java.lang.Long&nbsp;isbn)</code></th>
<td class="col-last">
<div class="block">Get an book by its ISBN</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<div class="inherited-list">
<h3 id="methods.inherited.from.class.java.lang.Object">Methods inherited from class&nbsp;java.lang.Object</h3>
<code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></div>
</section>
</li>
</ul>
</section>
<section class="details">
<ul class="details-list">
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<li>
<section class="constructor-details" id="constructor.detail">
<h2>Constructor Details</h2>
<ul class="member-list">
<li>
<section class="detail" id="&lt;init&gt;(fr.iut.librarymanagement.repository.BookRepository)">
<h3>BookController</h3>
<div class="member-signature"><span class="modifiers">public</span>&nbsp;<span class="member-name">BookController</span>&#8203;(<span class="parameters"><a href="../repository/BookRepository.html" title="interface in fr.iut.librarymanagement.repository">BookRepository</a>&nbsp;bookRepository)</span></div>
<dl class="notes">
<dt>Parameters:</dt>
<dd><code>bookRepository</code> - The BookRepository</dd>
</dl>
</section>
</li>
</ul>
</section>
</li>
<!-- ============ METHOD DETAIL ========== -->
<li>
<section class="method-details" id="method.detail">
<h2>Method Details</h2>
<ul class="member-list">
<li>
<section class="detail" id="bookList(java.lang.String)">
<h3>bookList</h3>
<div class="member-signature"><span class="annotations">@GetMapping(path="/books",
            produces="Application/json")
</span><span class="modifiers">public</span>&nbsp;<span class="return-type">java.util.List&lt;<a href="../domain/Book.html" title="class in fr.iut.librarymanagement.domain">Book</a>&gt;</span>&nbsp;<span class="member-name">bookList</span>&#8203;(<span class="parameters">@RequestParam(name="title",required=false)
java.lang.String&nbsp;title)</span></div>
<div class="block">Get all books, or looking for all books by title</div>
<dl class="notes">
<dt>Parameters:</dt>
<dd><code>title</code> - To looking for by title</dd>
<dt>Returns:</dt>
<dd>A list of book</dd>
</dl>
</section>
</li>
<li>
<section class="detail" id="getBookByIsbn(java.lang.Long)">
<h3>getBookByIsbn</h3>
<div class="member-signature"><span class="annotations">@GetMapping(path="/book/{isbn}",
            produces="Application/json")
</span><span class="modifiers">public</span>&nbsp;<span class="return-type"><a href="../domain/Book.html" title="class in fr.iut.librarymanagement.domain">Book</a></span>&nbsp;<span class="member-name">getBookByIsbn</span>&#8203;(<span class="parameters">@PathVariable
java.lang.Long&nbsp;isbn)</span></div>
<div class="block">Get an book by its ISBN</div>
<dl class="notes">
<dt>Parameters:</dt>
<dd><code>isbn</code> - The ISBN of the book</dd>
<dt>Returns:</dt>
<dd>The book</dd>
</dl>
</section>
</li>
<li>
<section class="detail" id="addBook(fr.iut.librarymanagement.domain.Book)">
<h3>addBook</h3>
<div class="member-signature"><span class="annotations">@PostMapping(path="/book",
             consumes="Application/json")
</span><span class="modifiers">public</span>&nbsp;<span class="return-type"><a href="../domain/Book.html" title="class in fr.iut.librarymanagement.domain">Book</a></span>&nbsp;<span class="member-name">addBook</span>&#8203;(<span class="parameters">@RequestBody
<a href="../domain/Book.html" title="class in fr.iut.librarymanagement.domain">Book</a>&nbsp;book)</span></div>
<div class="block">Create an book</div>
<dl class="notes">
<dt>Parameters:</dt>
<dd><code>book</code> - The book to be created</dd>
<dt>Returns:</dt>
<dd>The new book</dd>
</dl>
</section>
</li>
<li>
<section class="detail" id="deleteBook(java.lang.Long)">
<h3>deleteBook</h3>
<div class="member-signature"><span class="annotations">@DeleteMapping(path="/book/{isbn}")
</span><span class="modifiers">public</span>&nbsp;<span class="return-type">void</span>&nbsp;<span class="member-name">deleteBook</span>&#8203;(<span class="parameters">@PathVariable
java.lang.Long&nbsp;isbn)</span></div>
<div class="block">Delete a book</div>
<dl class="notes">
<dt>Parameters:</dt>
<dd><code>isbn</code> - The ISBN of the book to be deleted</dd>
</dl>
</section>
</li>
<li>
<section class="detail" id="addOpinion(java.lang.Long,fr.iut.librarymanagement.domain.Opinion)">
<h3>addOpinion</h3>
<div class="member-signature"><span class="annotations">@PostMapping(path="/book/{isbn}/opinion")
</span><span class="modifiers">public</span>&nbsp;<span class="return-type"><a href="../domain/Book.html" title="class in fr.iut.librarymanagement.domain">Book</a></span>&nbsp;<span class="member-name">addOpinion</span>&#8203;(<span class="parameters">@PathVariable
java.lang.Long&nbsp;isbn,
@RequestBody
<a href="../domain/Opinion.html" title="class in fr.iut.librarymanagement.domain">Opinion</a>&nbsp;opinion)</span></div>
<div class="block">Add an opinion to a book</div>
<dl class="notes">
<dt>Parameters:</dt>
<dd><code>isbn</code> - The ISBN of the book</dd>
<dd><code>opinion</code> - The opinion to be added</dd>
<dt>Returns:</dt>
<dd>The book, with the new opinion</dd>
</dl>
</section>
</li>
<li>
<section class="detail" id="editBook(java.lang.Long,java.lang.String,java.lang.String)">
<h3>editBook</h3>
<div class="member-signature"><span class="annotations">@PutMapping(path="/book/{isbn}")
</span><span class="modifiers">public</span>&nbsp;<span class="return-type"><a href="../domain/Book.html" title="class in fr.iut.librarymanagement.domain">Book</a></span>&nbsp;<span class="member-name">editBook</span>&#8203;(<span class="parameters">@PathVariable
java.lang.Long&nbsp;isbn,
@RequestParam(name="title",required=false)
java.lang.String&nbsp;title,
@RequestParam(name="summary",required=false)
java.lang.String&nbsp;summary)</span></div>
<div class="block">Update a book</div>
<dl class="notes">
<dt>Parameters:</dt>
<dd><code>isbn</code> - The ISBN of the book to be modified</dd>
<dd><code>title</code> - The title of the book</dd>
<dd><code>summary</code> - The summary of the book</dd>
<dt>Returns:</dt>
<dd>The modified book</dd>
</dl>
</section>
</li>
<li>
<section class="detail" id="addUser(java.lang.Long,org.bson.types.ObjectId)">
<h3>addUser</h3>
<div class="member-signature"><span class="annotations">@PostMapping(path="/book/{isbn}/user")
</span><span class="modifiers">public</span>&nbsp;<span class="return-type"><a href="../domain/Book.html" title="class in fr.iut.librarymanagement.domain">Book</a></span>&nbsp;<span class="member-name">addUser</span>&#8203;(<span class="parameters">@PathVariable
java.lang.Long&nbsp;isbn,
@RequestBody
org.bson.types.ObjectId&nbsp;userId)</span></div>
<div class="block">Add a user who has borrowed a book</div>
<dl class="notes">
<dt>Parameters:</dt>
<dd><code>isbn</code> - The ISBN of the borrowed book</dd>
<dd><code>userId</code> - The ID of the borrower</dd>
<dt>Returns:</dt>
<dd>The book, with the borrower</dd>
</dl>
</section>
</li>
<li>
<section class="detail" id="bookUserList(org.bson.types.ObjectId)">
<h3>bookUserList</h3>
<div class="member-signature"><span class="annotations">@GetMapping(path="/books/user/{userId}",
            produces="Application/json")
</span><span class="modifiers">public</span>&nbsp;<span class="return-type">java.util.List&lt;<a href="../domain/Book.html" title="class in fr.iut.librarymanagement.domain">Book</a>&gt;</span>&nbsp;<span class="member-name">bookUserList</span>&#8203;(<span class="parameters">@PathVariable
org.bson.types.ObjectId&nbsp;userId)</span></div>
<div class="block">Get all books borrowed by an user</div>
<dl class="notes">
<dt>Parameters:</dt>
<dd><code>userId</code> - The ID of the user</dd>
<dt>Returns:</dt>
<dd>The list of books of the user</dd>
</dl>
</section>
</li>
</ul>
</section>
</li>
</ul>
</section>
<!-- ========= END OF CLASS DATA ========= -->
</main>
<footer role="contentinfo">
<nav role="navigation">
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottom-nav" id="navbar.bottom">
<div class="skip-nav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<ul id="navbar.bottom.firstrow" class="nav-list" title="Navigation">
<li><a href="../../../../index.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="nav-bar-cell1-rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-files/index-1.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="sub-nav">
<div>
<ul class="sub-nav-list">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="sub-nav-list">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
</div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
<span class="skip-nav" id="skip.navbar.bottom">
<!--   -->
</span></nav>
</footer>
</div>
</div>
</body>
</html>
